/*Maeyeda's 2-tree method to evaluate topological formulas using
(Minty's algorithm for spanning tree enumeration
in Symbolic Network Analysis, Lin) */

#include <stdio.h>
#define ACTMAX 10 /* max active 4-ports */
#define EMAX (40+ACTMAX)   /* max edges */
#define NMAX 20  /* max nodes */
#define STK1 NMAX  /* minty alg. stack */
#define STK2 NMAX  /* traverse stack */
char trace[EMAX][EMAX];

main()
{
int e,n,r,a,act,d1[EMAX],d2[EMAX],d3[ACTMAX],d4[ACTMAX],v[NMAX],edge[EMAX],vstk[STK1][NMAX],
   estk[STK1][EMAX],tree[NMAX],vd1,vd2,i,j,scan;
char branch[EMAX][8];
/* scanf("%u %u",&e,&n); */
e = 1; /* first edge is always dummy */
n = 0;
a = 0;
act = 0;
scan = 1;
do{
/*printf("scanloop e= %d\r\n",e);*/
scanf("%s,%u,%u",&branch[e+1][0],&d1[e+1],&d2[e+1]);
/*printf("%s,%u,%u\n\r",&branch[e+1][0],d1[e+1],d2[e+1]);*/
if ( (branch[e+1][0] != 'x') && (branch[e+1][0] != 'X') ) {
if ( (branch[e+1][0] == 'k') || (branch[e+1][0] == 'K') ||
     (branch[e+1][0] == 'm') || (branch[e+1][0] == 'M') ||
     (branch[e+1][0] == 'f') || (branch[e+1][0] == 'F') ) {
scanf(",%u,%u",&d3[a+1],&d4[a+1]);
e++;
if ( d1[e] > n ) n = d1[e];
if ( d2[e] > n ) n = d2[e];
a++;
if ( d3[a] > n ) n = d3[a];
if ( d4[a] > n ) n = d4[a];
}
else
{
e++;
if ( d1[e] > n ) n = d1[e];
if ( d2[e] > n ) n = d2[e];
}
} else {
/* dummy edge (handle) and extra node */
d1[1] = n+1;
d2[1] = 1;
branch[1][0] = 'X';
branch[1][1] = 0;
n++;
scan = 0;
};
} while (scan == 1);
printf("e= %d, a=%d, n=%d\n\r",e ,a ,n);
for(i=1;i<=e-a;i++){
printf("%s,%d,%d\n\r",&branch[i][0],d1[i],d2[i]);
};
for(i=1;i<=a;i++){
printf("%s,%d,%d,%d,%d\n\r",&branch[i+e-a][0],d1[i+e-a],d2[i+e-a],d3[i],d4[i]);
};
e = e - a;
r = n - 1;
printf("Spanning Tree Admittance Products:\n\r");
/*printf(" Function: \n\r");
printf(" Numerator: \n\r");  */
printf(" V-tree: \n\r");
minty(n,(e+a),r,&d1,&d2,&v,&vstk,&estk,&edge,*tree,branch);
printf(" I-tree: \n\r");
for(i=1;i<=a;i++){
j = d1[e+i]; d1[e+i] = d3[i]; d3[i] = j;
j = d2[e+i]; d2[e+i] = d4[i]; d4[i] = j;
};
minty(n,(e+a),r,&d1,&d2,&v,&vstk,&estk,&edge,*tree,branch);
printf(" Denominator: \n\r"); 
for(i=1;i<=a;i++){
j = d1[e+i]; d1[e+i] = d3[i]; d3[i] = j;
j = d2[e+i]; d2[e+i] = d4[i]; d4[i] = j;
};
minty(n,e,r,&d1,&d2,&v,&vstk,&estk,&edge,*tree,branch);
printf(" End: \n\r");
}

void product(r,tree,branch)
int r,tree[];
char branch[][8];
{
int i,s;
s = 0;
for(i = 1;i < r;i++) { /* r is heavy by one here */
if ( branch[tree[i]][0] == 'c' ) s++;
if ( branch[tree[i]][0] == 'C' ) s++;
if ( branch[tree[i]][0] == 'l' ) s--;
if ( branch[tree[i]][0] == 'L' ) s--;
}
printf("+ s%d",s);
for(i = 1;i < r;i++) { /* r is heavy here too */
printf(" %s",&branch[tree[i]][0]);
}
printf("\n\r");
}




void minty(n,e,r,d1,d2,v,vstk,estk,edge,tree,branch)
int e,n,r,d1[],d2[],v[],edge[],vstk[][NMAX],
   estk[][EMAX],tree[];
char branch[][8];
{
int vd1,vd2,i,j,k,l,m,it,nt;
for(k=1;k <= e;k++)edge[k] = 1;
for(k=1;k <= n;k++)v[k] = 0;
it = 0;
i = 1;
nt = 0;
L15:
for(k=1;(k <= e);k++)if(edge[k] == 1)goto L40;
L25:
if(it == 1)return;
it--;
for(k=1;k <= e;k++)edge[k] = estk[it][k];
for(k=1,i = 0;k <= n;k++){v[k] = vstk[it][k];if(v[k] > i)i = v[k];};
i++;
goto L15;

L40:
l = k;
edge[l] = 0;
m = 0;
for(k=1;k <= e;k++)if(edge[k] != 0)m++;
if( m >= (n - 1))
{
for(k=1;k <= e;k++)estk[it][k] = edge[k];
for(k=1;k <= n;k++)vstk[it][k] = v[k];
it++;
}
L60:
edge[l] = -1;
vd1 = d1[l];
vd2 = d2[l];

if(v[vd1] == 0)goto L95;
if(v[vd2] == 0)goto L105;

l = v[vd1];
m = v[vd2];

if(l == m)goto L25;
if(l > m){k = m;m = l;l = k;};
for(k = 1;k <= n;k++){
if(v[k] > m)
 v[k]--;
else
 if(v[k] == m)
  v[k] = l;
};
i--;
goto L110;
L95:
if(v[vd2] == 0)goto L100;
v[vd1] = v[vd2];
goto L110;
L100:
v[vd1] = i;
v[vd2] = i;
i++;
goto L15;
L105:
v[vd2] = v[vd1];
L110:
for(k = 1;k <= n;k++)if(v[k] != 1)goto L15;
nt++;
l = 1;
for(k = 2;k <= e;k++) /* dummy edge 1 is always present, so skip it */
 if(edge[k] == -1){tree[l] = k;l++;};
/* printf(" Tree no. %3d\n\r",nt); */
/* for(k = 1;k <= r;k++)printf(" %2d ",tree[k]);
printf("\n\r"); */
product(r,tree,branch);
goto L25;

}
