/*tree16.c
   maeyeda's 2-tree method to evaluate topological formulas using
   (minty's algorithm for spanning tree enumeration
   in symbolic network analysis, lin) */

#include <stdio.h>

#define print_trees 0
/*#define debug 1*/
/* #define debugin 1 */

#define actmax 10               /* max active 2-ports */
#define pmax 40                 /*max passive (one-port) edges*/
#define emax (pmax+actmax)      /* max edges */
#define nmax 20                 /* max nodes */
#define stk1 nmax               /* minty alg. stack */
#define stk2 nmax               /* traverse stack */
#define tbuf1max 6000           /*v-tree  list to match i-trees */
#define tbuf2max 5000
#define vtree 1
#define itree 2

/* numerator and denominator indicators */
#define V     0
#define wijkl 1
#define wijij 2
#define wklkl 3
#define wklij 4
#define uijkl 5

int tbuf1overage,tbuf2overage;
int treebuf[tbuf1max][nmax];
int treepermbuf[tbuf1max][nmax];
int nbuf;
int treebuf2[tbuf2max][nmax], branchtag[emax];
int nbuf2, dtag;
int ni,nj,nk,nl,ni1,nj1,nk1,nl1,opampcnt, n, int_node, nodelist[nmax];
int p0[pmax], p1[pmax], p2[pmax];


    int e, p, r, a, d0[emax], d1[emax], d2[emax], a0[actmax], a1[actmax], a2[actmax],a3[actmax], a4[actmax],
      branches;
    char branch[emax][8];
main()
{
int i,j,k,scan, node1, node2, node3, node4, int1, int2, ch0, ch1, f;
printf("program file name tree16.c\n\r");
printf("\n\r\n\rinput data:\n\r\n\r");
    p = 1;                      /* first edge is always dummy */
    branches = 1;
    n = 0;
    int_node = 999;
    a = 0;
    f = 0;

    for (scan = 1; scan == 1;) {
        scanf("%s", &branch[branches + 1][0]);
        printf("%s", &branch[branches + 1][0]);
        ch0 = branch[branches + 1][0];
        ch1 = branch[branches + 1][1];
        if ( (((ch0 == 'g') || (ch0 == 'G') || (ch0 == 'r') || (ch0 == 'R') ) && ((ch1 == 'm') || (ch1 == 'M'))) ||
            (ch0 == 'o') || (ch0 == 'O') || (ch0 == 'u') || (ch0 == 'U') || (ch0 == 'b') || (ch0 == 'B') ){
            scanf(" %u %u %u %u", &node1, &node2, &node3, &node4);
            printf(" %u %u %u %u\n\r", node1, node2, node3, node4);
         switch(ch0){
          case 'g':
          case 'G':
          case 'o':
          case 'O':
            branches++;
            a++;
            a0[a] = branches;
            a1[a] = nodemap(node1);
            a2[a] = nodemap(node2);
            a3[a] = nodemap(node3);
            a4[a] = nodemap(node4);
           break;
          case 'r':
          case 'R':

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node3);
            p2[p] = internal_node();

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = internal_node();
            a2[a] = nodemap(node2);
            a3[a] = nodemap(node4);
            a4[a] = p2[p];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = nodemap(node1);
            a2[a] = nodemap(node2);
            a3[a] = nodemap(node2);
            a4[a] = a1[a-1];
            branch[branches][0] = 'o';
            branch[branches][1] = 0;



            branches++;
            a++;
            a0[a] = branches;
            a1[a] = p2[p];
            a2[a] = nodemap(node4);
            a3[a] = nodemap(node4);
            a4[a] = nodemap(node3);
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node1);
            p2[p] = a1[a-2];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

           break;

          case 'u':
          case 'U':
            branches++;
            a++;
            a0[a] = branches;
            a1[a] = internal_node();
            a2[a] = nodemap(node2);
            a3[a] = nodemap(node3);
            a4[a] = nodemap(node4);

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = nodemap(node1);
            a2[a] = nodemap(node2);
            a3[a] = nodemap(node2);
            a4[a] = a1[a-1];
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = a1[a-1];
            p2[p] = nodemap(node1);
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

           break;

          case 'b':
          case 'B':
            branches++;
            a++;
            a0[a] = branches;
            a1[a] = nodemap(node2);
            a2[a] = nodemap(node1);
            a3[a] = internal_node();
            a4[a] = nodemap(node4);

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = a3[a-1];
            a2[a] = nodemap(node4);
            a3[a] = nodemap(node4);
            a4[a] = nodemap(node3);
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node3);
            p2[p] = a3[a-1];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

           break;

        }
       }
         else
            if((ch0 == 'm') || (ch0 == 'M')){
            scanf(" %u %u %u %u", &node1, &node2, &node3, &node4);
            printf(" %u %u %u %u\n\r", node1, node2, node3, node4);

            int1 = internal_node();
            int2 = internal_node();

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node3);
            p2[p] = internal_node();
            k = branches;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = internal_node();
            a2[a] = int2;
            a3[a] = int1;
            a4[a] = p2[p];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = nodemap(node1);
            a2[a] = int2;
            a3[a] = int2;
            a4[a] = a1[a-1];
            branch[branches][0] = 'o';
            branch[branches][1] = 0;


            branches++;
            a++;
            a0[a] = branches;
            a1[a] = p2[p];
            a2[a] = int1;
            a3[a] = int1;
            a4[a] = nodemap(node3);
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node1);
            p2[p] = a1[a-2];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;


/* second part */

            branches++;
            p++;
            for(i = 0;(branch[branches][i] = branch[k][i]) != 0; i++);
            p0[p] = branches;
            p1[p] = int2;
            p2[p] = internal_node();

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = internal_node();
            a2[a] = nodemap(node4);
            a3[a] = nodemap(node2);
            a4[a] = p2[p];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = int1;
            a2[a] = nodemap(node4);
            a3[a] = nodemap(node4);
            a4[a] = a1[a-1];
            branch[branches][0] = 'o';
            branch[branches][1] = 0;


            branches++;
            a++;
            a0[a] = branches;
            a1[a] = p2[p];
            a2[a] = nodemap(node2);
            a3[a] = nodemap(node2);
            a4[a] = int2;
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = int1;
            p2[p] = a1[a-2];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;



              }
        if ( ((ch0 == 'g') || (ch0 == 'G') ) && ((ch1 == 'y') || (ch1 == 'Y'))) {
            scanf(" %u %u %u %u", &node1, &node2, &node3, &node4);
            printf(" %u %u %u %u\n\r", node1, node2, node3, node4);

            int1 = internal_node();
            int2 = internal_node();

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node3);
            p2[p] = internal_node();
            k = branches;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = internal_node();
            a2[a] = int2;
            a3[a] = int1;
            a4[a] = p2[p];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = nodemap(node1);
            a2[a] = int2;
            a3[a] = int2;
            a4[a] = a1[a-1];
            branch[branches][0] = 'o';
            branch[branches][1] = 0;


            branches++;
            a++;
            a0[a] = branches;
            a1[a] = p2[p];
            a2[a] = int1;
            a3[a] = int1;
            a4[a] = nodemap(node3);
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node1);
            p2[p] = a1[a-2];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

/* second part */

            branches++;
            p++;
            for(i = 0;(branch[branches][i] = branch[k][i]) != 0; i++);
            p0[p] = branches;
            p1[p] = nodemap(node2);
            p2[p] = internal_node();

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = internal_node();
            a2[a] = nodemap(node4);
            a3[a] = int2;
            a4[a] = p2[p];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;

            branches++;
            a++;
            a0[a] = branches;
            a1[a] = int1;
            a2[a] = nodemap(node4);
            a3[a] = nodemap(node4);
            a4[a] = a1[a-1];
            branch[branches][0] = 'o';
            branch[branches][1] = 0;


            branches++;
            a++;
            a0[a] = branches;
            a1[a] = p2[p];
            a2[a] = int2;
            a3[a] = int2;
            a4[a] = nodemap(node2);
            branch[branches][0] = 'o';
            branch[branches][1] = 0;

            branches++;
            p++;
            p0[p] = branches;
            p1[p] = int1;
            p2[p] = a1[a-2];
            branch[branches][0] = 'a';
            branch[branches][1] = 0;



        }
        else
             if( (ch0 == 'f') || (ch0 == 'F')) {
              if(f == 1){
               printf("error-- more than one port indicator is used\n\r");
               return;
               };
               f = 1;
            scanf(" %u %u %u %u", &ni1, &nj1, &nk1, &nl1);
            printf(" %u %u %u %u\n\r", ni1, nj1, nk1, nl1);
               ni = nodemap(ni1);
               nj = nodemap(nj1);
               nk = nodemap(nk1);
               nl = nodemap(nl1);
              }
               else
                  if( (ch0 == 'g') || (ch0 == 'G') ||
                    (ch0 == 'z') || (ch0 == 'Z') ||
                    (ch0 == 'y') || (ch0 == 'Y') ||
                    (ch0 == 'r') || (ch0 == 'R') ||
                    (ch0 == 'l') || (ch0 == 'L') ||
                    (ch0 == 'c') || (ch0 == 'C') ){
            scanf(" %u %u", &node1, &node2);
            printf(" %u %u\n\r", node1, node2);
            branches++;
            p++;
            p0[p] = branches;
            p1[p] = nodemap(node1);
            p2[p] = nodemap(node2);
                   }
             else
             if( (ch0 == 'e') || (ch0 == 'E')) {
/* dummy edge (handle) and extra node */
            p0[1] = 1;
            p1[1] = n + 1;
            p2[1] = 1;
            branch[1][0] = 'x';
            branch[1][1] = 0;
            n++;
            scan = 0;
        }
             else
             if( (ch0 == 'h') || (ch0 == 'H')) {
             printf("\n\rhelp:\n\r");
             printf("one-port (two-terminal) passive elements:\n\r");
             printf("r,l,c,g,y,z (lower case or upper case) prefix, null up to 8 character suffix,\n\r");
             printf("whitespace, first node#(0-999),whitespace,second node#(0-999) examples--\n\r");
             printf("r 0 4\n\r");
             printf("L23a 7 41\n\r");
             printf("g2 3 8\n\r");
             printf("(gm, gy, and rm are reserved for two-port elements)\n\r");
             printf("two-port (four-terminal) active elements:\n\r");
             printf("gm,gy,o,u,b,rm,m (lower case or upper case) prefix, null up to 8 character suffix,\n\r");
             printf("whitespace, +output node#, whitespace, -output node#, whitespace, +input node#, whitespace, -input node#,\n\r");
             printf("positive current enters +nodes.\n\r");
             printf("gm denotes voltage controlled current source,\n\r");
             printf("o denotes ideal op amp,\n\r");
             printf("u (mu) denotes voltage controlled voltage source,\n\r");
             printf("b (beta) denotes current controlled current source,\n\r");
             printf("rm denotes current controlled voltage source,\n\r");
             printf("gy denotes a gyrator, and\n\r");
             printf("m denotes a mutual inductance\n\r");
             printf("examples--\n\r");
             printf("gm2 1 2 3 4\n\r");
             printf("U3 3 0 7 5\n\r");
             printf("o 6 3 2 9\n\r");
             printf("O 3 1 3 4\n\r");
             printf("f (lower case or upper case),\n\r");
             printf("whitespace, +port1 node#, whitespace, -port1 node#, whitespace, +port2 node#, whitespace, -port2 node#\n\r");
             printf("f 1 0 2 0\n\r");
             printf("e or end  terminates input\n\r");
             return;
        }
           else

              {
                  printf("unrecognized element prefix-- '%s': must be r,l,c,g,y,z,gm,gy,o,u,b,rm,m,f,e\n\r",&branch[branches + 1][0]);
                  printf("h as input prints help\n\r");
                  return;
              };



        if(p >= pmax)
         {
           printf("number of one-port elements(= %d) exceeds limit of %d\n\r or improper input applied\n\r",p,pmax-1);
           return;
         };

        if(a >= actmax)
         {
           printf("number of two-port elements(= %d) exceeds limit of %d\n\r or improper input applied\n\r",a,actmax-1);
           return;
         };


    }
    printf("\n\r\n\r\n\r");

    e = p;
    r = n - 1;


#ifdef debugin
    printf("Internal representation of data including generated elements and reassigned node#s:\n");
    for (i = 1; i <= p; i++) {
        printf("%s %d %d\n", &branch[p0[i]][0], p1[i], p2[i]);
    };
    for (i = 1; i <= a; i++) {
        printf("%s %d %d %d %d\n", &branch[a0[i]][0], a1[i], a2[i], a3[i], a4[i]);
    };
        printf("f %d %d %d %d\n\n", ni, nj, nk, nl);
#endif

/* numerator and denominator indicators
#define V     0
#define wijkl 1
#define wijij 2
#define wklkl 3
#define wklij 4
#define wklij 4
#define uijkl 5
*/

/*
transfer ratios:
Vkl/Vij = wijkl/wijij
Ikl/Iij = -wijkl/wklkl
open circuit admittance functions:
Iij/Vij = V/wijij
Ikl/Vij = V/wklij
Iij/Vkl = V/wijkl
Ikl/Vkl = V/wklkl
short circuit admittance functions:
Iij/Vij = wklkl/uijkl
Iij/Vkl = -wklij/uijkl
Ikl/Vij = -wijkl/uijkl
Ikl/Vkl = wijij/uijkl
*/

#define ev_fn(s,n,d) evaluate_fn(e,a,r, s,n,d)

printf(" Function:\n\n V( %d, %d)/V( %d, %d) for I( %d, %d)=0\n",nk1,nl1,ni1,nj1,nk1,nl1);
ev_fn(1,wijkl,wijij);

printf(" Function:\n\n V( %d, %d)/V( %d, %d) for I( %d, %d)=0\n",ni1,nj1,nk1,nl1,ni1,nj1);
ev_fn(1,wklij,wklkl);

printf(" Function:\n\n I( %d, %d)/I( %d, %d) for V( %d, %d)=0\n",nk1,nl1,ni1,nj1,nk1,nl1);
ev_fn(-1,wijkl,wklkl);

printf(" Function:\n\n I( %d, %d)/I( %d, %d) for V( %d, %d)=0\n",ni1,nj1,nk1,nl1,ni1,nj1);
ev_fn(-1,wklij,wijij);

printf(" Function:\n\n Y( %d, %d; %d, %d) = I( %d, %d)/V( %d, %d) for V( %d, %d)=0\n"
       ,ni1,nj1,ni1,nj1,ni1,nj1,ni1,nj1,nk1,nl1);
ev_fn(1,wklkl,uijkl);

printf(" Function:\n\n Y( %d, %d; %d, %d) = I( %d, %d)/V( %d, %d) for V( %d, %d)=0\n"
       ,nk1,nl1,ni1,nj1,nk1,nl1,ni1,nj1,nk1,nl1);
ev_fn(-1,wijkl,uijkl);

printf(" Function:\n\n Y( %d, %d; %d, %d) = I( %d, %d)/V( %d, %d) for V( %d, %d)=0\n"
       ,ni1,nj1,nk1,nl1,ni1,nj1,nk1,nl1,ni1,nj1);
ev_fn(-1,wklij,uijkl);

printf(" Function:\n\n Y( %d, %d; %d, %d) = I( %d, %d)/V( %d, %d) for V( %d, %d)=0\n"
       ,nk1,nl1,nk1,nl1,nk1,nl1,nk1,nl1,ni1,nj1);
ev_fn(1,wijij,uijkl);

printf(" Function:\n\n Z( %d, %d; %d, %d) = V( %d, %d)/I( %d, %d) for I( %d, %d)=0\n"
       ,ni1,nj1,ni1,nj1,ni1,nj1,ni1,nj1,nk1,nl1);
ev_fn(1,wijij,V);

printf(" Function:\n\n Z( %d, %d; %d, %d) = V( %d, %d)/I( %d, %d) for I( %d, %d)=0\n"
       ,nk1,nl1,ni1,nj1,nk1,nl1,ni1,nj1,nk1,nl1);
ev_fn(1,wijkl,V);

printf(" Function:\n\n Z( %d, %d; %d, %d) = V( %d, %d)/I( %d, %d) for I( %d, %d)=0\n"
       ,ni1,nj1,nk1,nl1,ni1,nj1,nk1,nl1,ni1,nj1);
ev_fn(1,wklij,V);

printf(" Function:\n\n Z( %d, %d; %d, %d) = V( %d, %d)/I( %d, %d) for I( %d, %d)=0\n"
       ,nk1,nl1,nk1,nl1,nk1,nl1,nk1,nl1,ni1,nj1);
ev_fn(1,wklkl,V);

}

int nodemap(node)
int node;
{
int i;
if(node > 999){
 printf("node label %d must be less than 1000\n\r",node);
 return(1);
 };

for(i = 1; i <= n; i++){
  if(nodelist[i] == node)return(i);
};
        if(n >= nmax)
         {
           printf("number of nodes(= %d) exceeds limit of %d\n\r or improper input applied\n\r",n,nmax-1);
           return(1);
         };
n++;
nodelist[n] = node;
return(n);
}

int internal_node()
{
        if(n >= nmax)
         {
           printf("number of nodes(= %d) exceeds limit of %d\n\r or improper input applied\n\r",n,nmax-1);
           return(1);
         };

n++;
int_node++;
nodelist[n] = int_node;
return(n);
}

evaluate_fn(e,a,r, sign, numerator, denominator)
int e,a,r,sign,numerator,denominator;
{
int i, j, n,passive_edges,minty_nodes,actual_nodes,active_edges,numerator_form,denominator_form ;

opampcnt = 0;
minty_nodes = r + 1;
actual_nodes = r;
passive_edges = e;
    nbuf = 0;
    nbuf2 = 0;
    tbuf1overage = 0;
    tbuf2overage = 0;
    for (i = 0; i <= (e + a); i++)
        branchtag[i] = 0;

    for (i = 1; i <= e; i++) {
        d0[i] = p0[i];
        d1[i] = p1[i];
        d2[i] = p2[i];
    };

    for (i = 1; i <= a; i++) {
        d0[e + i] = a0[i];
        d1[e + i] = a1[i];
        d2[e + i] = a2[i];
    };


    switch(numerator){
    case V:
printf("V:\n\r");
          active_edges = a;
          numerator_form = 1;
          for (i = 1; i <= a; i++) {
                j = d1[e + i];
                d1[e + i] = d2[e + i];
                d2[e + i] = j;
          };
          break;

    case wijkl:
printf("wijkl:\n\r");
          active_edges = a + 1;
          numerator_form = 0;
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          d0[e+a+1] = branches+1;
          break;

    case wijij:
printf("wijij:\n\r");
          active_edges = a + 1;
          numerator_form = 0;
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          break;

    case wklkl:
printf("wklkl:\n\r");
          active_edges = a + 1;
          numerator_form = 0;
          d1[e+a+1] = nk;
          d2[e+a+1] = nl;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          break;

    case wklij:
printf("wklij:\n\r");
          active_edges = a + 1;
          numerator_form = 0;
          d1[e+a+1] = nk;
          d2[e+a+1] = nl;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          d0[e+a+1] = branches+1;
          break;

    case uijkl:
printf("uijkl:\n\r");
          active_edges = a + 2;
          numerator_form = 2;
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = '1';
          branch[branches+1][2] = 0;
          d1[e+a+2] = nk;
          d2[e+a+2] = nl;
          d0[e+a+2] = branches+2;
          branch[branches+2][0] = 'f';
          branch[branches+2][1] = '2';
          branch[branches+2][2] = 0;
          break;

    };
#ifdef debug
printf("vtree for numerator starts\n\r");
#endif
    minty(minty_nodes,passive_edges+active_edges,actual_nodes,
            passive_edges,vtree,numerator_form);

    switch(numerator){
    case V:
          break;

    case wijkl:
          d1[e+a+1] = (sign == 1)?nk:nl;
          d2[e+a+1] = (sign == 1)?nl:nk;
          break;

    case wijij:
          if(sign == -1){
          j = d1[e+a+1];
          d1[e+a+1] = d2[e+a+1];
          d2[e+a+1] = j;
          };
          break;

    case wklkl:
          if(sign == -1){
          j = d1[e+a+1];
          d1[e+a+1] = d2[e+a+1];
          d2[e+a+1] = j;
          };
          break;

    case wklij:
          d1[e+a+1] = (sign == 1)?ni:nj;
          d2[e+a+1] = (sign == 1)?nj:ni;
          break;

    case uijkl:
          break;

    };

    for (i = 1; i <= a; i++) {
        d1[e + i] = a3[i];
        d2[e + i] = a4[i];
    };

#ifdef debug
printf("itree for numerator starts\n\r");
#endif
    minty(minty_nodes,passive_edges+active_edges,actual_nodes,
            passive_edges,itree,numerator_form);


    for (i = 1; i <= a; i++) {
        d1[e + i] = a1[i];
        d2[e + i] = a2[i];
    };


    switch(numerator){
    case V:
          break;

    case wijkl:
          break;

    case wijij:
          break;

    case wklkl:
          break;

    case wklij:
          break;

    case uijkl:
          break;

    };


    if(tbuf1overage != 0)printf("tbuf1max exceeded by %d trees\n\r",tbuf1overage);

    tbuf1overage = 0;

    nbuf = 0;
    dtag = nbuf2 + 1;


    switch(denominator){
    case V:
printf("V:\n\r");
          active_edges = a;
          denominator_form = 1;
          break;

    case wijkl:
printf("wijkl:\n\r");
          active_edges = a + 1;
          denominator_form = 0;
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          break;

    case wijij:
printf("wijij:\n\r");
          active_edges = a + 1;
          denominator_form = 0;
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          break;

    case wklkl:
printf("wklkl:\n\r");
          active_edges = a + 1;
          denominator_form = 0;
          d1[e+a+1] = nk;
          d2[e+a+1] = nl;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          break;


    case wklij:
printf("wklij:\n\r");
          active_edges = a + 1;
          denominator_form = 0;
          d1[e+a+1] = nk;
          d2[e+a+1] = nl;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = 0;
          break;

    case uijkl:
printf("uijkl:\n\r");
          active_edges = a + 2;
          denominator_form = 2;
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          d0[e+a+1] = branches+1;
          branch[branches+1][0] = 'f';
          branch[branches+1][1] = '1';
          branch[branches+1][2] = 0;
          d1[e+a+2] = nk;
          d2[e+a+2] = nl;
          d0[e+a+2] = branches+2;
          branch[branches+2][0] = 'f';
          branch[branches+2][1] = '2';
          branch[branches+2][2] = 0;
          break;

    };

#ifdef debug
printf("vtree for denominator starts\n\r");
#endif
    minty(minty_nodes,passive_edges+active_edges,actual_nodes,
            passive_edges,vtree,denominator_form);


    for (i = 1; i <= a; i++) {
        d1[e + i] = a3[i];
        d2[e + i] = a4[i];
    };


    switch(denominator){
    case V:
          break;

    case wijkl:
          d1[e+a+1] = nk;
          d2[e+a+1] = nl;
          break;

    case wijij:
          break;

    case wklkl:
          break;

    case wklij:
          d1[e+a+1] = ni;
          d2[e+a+1] = nj;
          break;

    case uijkl:
          break;

    };

#ifdef debug
printf("itree for denominator starts\n\r");
#endif
    minty(minty_nodes,passive_edges+active_edges,actual_nodes,
            passive_edges,itree,denominator_form);


    for (i = 1; i <= a; i++) {
        d1[e + i] = a3[i];
        d2[e + i] = a4[i];
    };


    switch(denominator){
    case V:
          for (i = 1; i <= a; i++) {
                j = d1[e + i];
                d1[e + i] = d2[e + i];
                d2[e + i] = j;
          };
          break;

    case wijkl:
          for (i = 1; i <= a; i++) {
                j = d1[e + i];
                d1[e + i] = d2[e + i];
                d2[e + i] = j;
          };
          break;

    case wijij:
          break;

    case wklkl:
          break;

    case wklij:
          break;

    case uijkl:
          break;

    };

    if(tbuf1overage != 0)printf("tbuf1max exceeded by %d trees\n\r",tbuf1overage);

    if(tbuf2overage != 0)printf("tbuf2max exceeded by %d trees\n\r",tbuf2overage);

    print_treebuf2((e + a), 1 /*sign*/,3);

}


collect_tree(r, sign, tree, q)
int r, sign, q, tree[];
{
/* q == 0 rejects all trees without 'f' branch; q == 1 rejects all trees with 'f' branch;
   q == 2 rejects all trees without both 'f1' and 'f2 branches */
/* branchtag collects all the impedance-unit factors to be divided out later */
    int s, i, f, f1, f2, op, ch0, ch1;

#ifdef debug
printf("<");
   for(i = 1;i <= r;i++) {
   if ( (branch[d0[tree[i]]][0] == 'f') && (q < 3)  )continue;
   printf(" %s",&branch[d0[tree[i]]][0]);
   }
   printf(">\n");
#endif

    s = 0;
    f = 0;
    f1 = 0;
    f2 = 0;
    for (i = 1; i <= r; i++) {
        if ((branch[d0[tree[i]]][0] == 'f') ||
            (branch[d0[tree[i]]][0] == 'F')){
            f = 1;
            if((branch[d0[tree[i]]][1] == '1'))
               f1 = 1;
            if((branch[d0[tree[i]]][1] == '2'))
               f2 = 1;
        }
    }
     if (((q == 0) || (q == 1)) && (q == f))
            return;
     if ( (q == 2) && ( (f1 == 0) || (f2 == 0) ) )
           return;
    if (nbuf2 >= (tbuf2max - 1)) {
        if(tbuf2overage == 0)printf("treebuf2 is full\n");
        tbuf2overage++;
        return;
    };
    nbuf2++;
    treebuf2[nbuf2][0] = (sign == 1) ? r : (-r);
    for (i = 1, op = 0; i <= r; i++) {
        ch0 = branch[d0[tree[i]]][0];
        if ((ch0 == 'r') ||
            (ch0 == 'R') ||
            (ch0 == 'z') ||
            (ch0 == 'Z') ||
            (ch0 == 'l') ||
            (ch0 == 'L') ||
            (ch0 == 'm') ||
            (ch0 == 'M'))
            branchtag[d0[tree[i]]] = 1;
        if ((ch0 == 'o') ||
            (ch0 == 'O'))
          op++;
        treebuf2[nbuf2][i] = tree[i];
    };
    if( opampcnt < op)opampcnt = op;
}



print_treebuf2(n, sign, q)
int n, sign, q;
{
    int s, i, j, k, ch0, r, f, op, tmptree[emax], term[nmax];
printf("opampcnt= %d\n\r",opampcnt);
#ifdef debug
printf("nbuf2=%d, dtag=%d\n",nbuf2,dtag);
#endif
   init();

    printf("\n Numerator:\n\n");

   if( dtag <= 1)
    printf(" Null Numerator\n\n");



    for (i = 1; i <= nbuf2; i++) {
        if ( (i == dtag) ){
            printexp(); /* numerator*/
            init();
            sign = 1;
            printf("\n Denominator:\n\n");
        }

        r = treebuf2[i][0];
        r = (r > 0) ? r : (-r);

/* opamp constraint */
        for (j = 1, op = 0; j <= r; j++)
            if( (branch[d0[treebuf2[i][j]]][0] == 'o') ||
                (branch[d0[treebuf2[i][j]]][0] == 'O') )
             op++;

        if( op != opampcnt) continue;

        for (j = 1; j <= n; j++)
            tmptree[j] = 0;

        for (j = 1; j <= r; j++)
            tmptree[d0[treebuf2[i][j]]] = 1;
/* (branchtag == tmptree == 0) means no factor in tree or cancellation list
   (branchtag == tmptree == 1) means the factor in tree is cancelled by cancellation list
   (branchtag != tmptree) means factor is due to either tree or cancellation list */
        for (j = 1; j <= n; j++)
            if (branchtag[j] == tmptree[j])
                tmptree[j] = 0;
            else
                tmptree[j] = 1;
/*if(i<dtag){
   printf("**");
   for (j=1;j<=n;j++)printf("%1d",tmptree[j]);
   printf("\n");
   }; */
        s = 0;
        f = 0;
        for (j = 1; j <= n; j++) {
            if (tmptree[j] == 0)
                continue;
            k = branch[j][0];
            if (k == 'c')
                s++;
            if (k == 'C')
                s++;
            if (k == 'm')
                s++;
            if (k == 'M')
                s++;
            if (k == 'l')
                s++;
            if (k == 'L')
                s++;
        }
#if print_trees
        printf(" %s s%d", ((sign*treebuf2[i][0]) > 0) ? "+" : "-", s);
#endif
        for (j = 1, k = 0; j <= n; j++) {
            if (tmptree[j] == 0)
                continue;
            ch0 = branch[j][0];
            if (((ch0 == 'f') || (ch0 == 'F')) && (q < 3))
                continue;
            if (((ch0 == 'o') || (ch0 == 'O')))
                continue;
            /* elements of type 'a' are suppressed in all products,
               since they are considered to have unit values. */
            if (ch0 == 'a')
                continue;
             term[k] = j;
            k++;
#if print_trees
            printf(" %s", &branch[d0[j]][0]);
#endif
        };
#if print_trees
         printf("\n");
#endif

        getexpr( (((sign*treebuf2[i][0]) > 0) ? 1 : -1), s, k, term, n);
    }


    printexp();/* denominator or numerator if null denominator*/
    init();

    if ( (dtag == (nbuf2 + 1)) ){
    printf("\n Denominator:\n\n");

    printf(" Null Denominator\n\n");
    };


    printf("\n End: \n\n");

}


treecheck(r, pe, tree, perm)
int r, pe, tree[], perm[];
{
    int stack[nmax], tag[nmax];
    int depth, i, j, done, root_node, princip_node;

/*printf("treecheck, r=%d\n",r); */
    for (i = 1; i <= r; i++) {
        tag[i] = 0;
/*printf("%s %d d1=%d, d2=%d\n",&branch[d0[tree[i]]][0],tree[i],d1[tree[i]],d2[tree[i]]); */
    };
/*printf("\n"); */

    perm[0] = 0;
    perm[1] = 0;
    stack[0] = 1;
    depth = 0;
    for (done = 0; done == 0;) {
        root_node = stack[depth];
        for (i = 1; i <= r; i++) {
            if (tag[i] == 1)
                continue;
            if (d1[tree[i]] == root_node) {
                tag[i] = 1;
                princip_node = d2[tree[i]];
                perm[princip_node] = tree[i];
                break;
            };
            if (d2[tree[i]] == root_node) {
                tag[i] = 1;
                princip_node = d1[tree[i]];
                perm[princip_node] =  (-tree[i]);
                break;
            };
        };
        if (i <= r) {
            depth++;
            stack[depth] = princip_node;
        } else {
            if (depth > 0)
                depth--;
            else
                done = 1;
        };
    };
/*printf("permutation list:\n");
   for(i=0; i<=r+1;i++){
   printf("%3d ",perm[i]);
   };
   printf("\n"); */
    return;
}




product(r, tree, pe, pass, f)
int r, pass, pe, tree[], f;
{
    int i, j, k, m, n, s, sign, tmp, permbuf[nmax];

    switch (pass) {
    case vtree:
        /*if (tree[r - 1] > pe)*/ {
            if (nbuf >= (tbuf1max - 1)) {
                if(tbuf1overage == 0)printf("treebuf is full\n");
                tbuf1overage++;
                return;
            };
            for (i = 1; i < r; i++) {
                treebuf[nbuf][i] = tree[i];
            };
            treecheck(r - 1, pe, tree, &treepermbuf[nbuf][0]);
            nbuf++;
        };
        break;
    case itree:
        sign = 1;
        /*if (tree[r - 1] > pe)*/ {
            m = 0;
/*  for(i=0,j=nbuf-1;(nbuf>0)&&(j>i);)
   k = (i+j)/2;
 */
            for (k = 0; k < nbuf; k++) {
/*    printf("search i,j,k=%d, %d, %d\n",i,j,k); */
                for (n = r - 1; n > 0; n--) {
/*  printf("k,n,treebuf[k][n],tree[n]=%d %d %d %d\n",k,n,treebuf[k][n],tree[n]); */
                    if (treebuf[k][n] > tree[n]) {
                        j = k;
                        m = 0;
                        break;
                    } else if (treebuf[k][n] < tree[n]) {
                        i = k;
                        m = 0;
                        break;
                    }
                    m = 1;
                };
                if ((n == 0) && (m == 1)) {
                    break;
                };
            };
            if (m == 0) {
                return;
            };
            sign = 1;
            treecheck(r - 1, pe, tree, &permbuf[0]);


/* capture the principal node component of the sign computation */
            for (i = 2; i <= r; i++) {
                if (treepermbuf[k][i] < 0) {
                    sign = sign * (-1);
                    treepermbuf[k][i] = (-treepermbuf[k][i]);
                };
                if (permbuf[i] < 0) {
                    sign = sign * (-1);
                    permbuf[i] = (-permbuf[i]);
                };
            };
/*printf("sign1= %2d\n",sign); */
/* capture the permutation component of the sign computation */
            for (i = 2; i <= r; i++) {
                                                /*if(tree[i] > pe) */  {
                                                /*expect no permutation for the passive part */
                    if (treepermbuf[k][i] != permbuf[i]) {
                        sign = sign * (-1);
                        for (j = i + 1; j <= r; j++) {
                            if (treepermbuf[k][j] == permbuf[i]) {
                                tmp = treepermbuf[k][j];
                                treepermbuf[k][j] = treepermbuf[k][i];
                                treepermbuf[k][i] = tmp;
                                break;
                            };
                        };
                    };
                };
            };
/*for(i=0;i<=r;i++){
   printf("%3d ",permbuf[i]);
   };printf("\n");
   for(i=0;i<=r;i++){
   printf("%3d ",treepermbuf[k][i]);
   };printf("\n");
*/
/*   printf("resulting sign= %2d\n",sign); */
        };
        collect_tree(r - 1, sign, tree, f);
        break;
    };

}



minty(n, e, r,  pe, pass, f)
int e, n, r, pe, pass, f;
{
    int vd1, vd2, i, j, k, l, m, it, nt;
    int v[nmax], edge[emax], vstk[stk1][nmax], estk[stk1][emax], tree[nmax];

#ifdef debug
 printf("e,n,r,pe,pass=%d %d %d %d %d\n",e,n,r,pe,pass);
for(i = 0;i <= e; i++)printf("%s: d1[%d]= %d, d2= %d\n\r",&branch[d0[i]][0],i,d1[i],d2[i]);
printf("\n\r\n\r");
#endif

    for (k = 1; k <= e; k++)
        edge[k] = 1;
    for (k = 1; k <= n; k++)
        v[k] = 0;
    it = 0;
    i = 1;
    nt = 0;
  l15:
    for (k = 1; (k <= e); k++)
        if (edge[k] == 1)
            goto l40;
  l25:
/*printf("it=%d\n",it); */
    if (it <= 1)
        return;
    it--;
    for (k = 1; k <= e; k++)
        edge[k] = estk[it][k];
    for (k = 1, i = 0; k <= n; k++) {
        v[k] = vstk[it][k];
        if (v[k] > i)
            i = v[k];
    };
/*printf("pop stack: edge=");
   for(k=1;k <= e;k++)printf("%d,",edge[k]);
   printf("\nvertex=");
   for(k=1;k <= n;k++)printf("%d,",v[k]);
   printf("\n"); */
    i++;
    goto l15;

  l40:
    l = k;
    edge[l] = 0;
    m = 0;
    for (k = 1; k <= e; k++)
        if (edge[k] != 0)
            m++;
    if (m >= (n - 1)) {
/*printf("push\n"); */

        for (k = 1; k <= e; k++)
            estk[it][k] = edge[k];
        for (k = 1; k <= n; k++)
            vstk[it][k] = v[k];
        it++;
    }
  l60:
    edge[l] = -1;
    vd1 = d1[l];
    vd2 = d2[l];

    if (v[vd1] == 0)
        goto l95;
    if (v[vd2] == 0)
        goto l105;

    l = v[vd1];
    m = v[vd2];

    if (l == m)
        goto l25;
    if (l > m) {
        k = m;
        m = l;
        l = k;
    };
    for (k = 1; k <= n; k++) {
        if (v[k] > m)
            v[k]--;
        else if (v[k] == m)
            v[k] = l;
    };
    i--;
    goto l110;
  l95:
    if (v[vd2] == 0)
        goto l100;
    v[vd1] = v[vd2];
    goto l110;
  l100:
    v[vd1] = i;
    v[vd2] = i;
    i++;
    goto l15;
  l105:
    v[vd2] = v[vd1];
  l110:
    for (k = 1; k <= n; k++)
        if (v[k] != 1)
            goto l15;
    nt++;
    l = 1;
    for (k = 2; k <= e; k++)    /* dummy edge 1 is always present, so skip it */
        if (edge[k] == -1) {
            tree[l] = k;
            l++;
        };
#ifdef print_trees
 printf(" tree no. %3d\n",nt);
   for(k = 1;k < r;k++)printf(" %2d ",tree[k]);
   printf("\n");
#endif

    product(r, tree, pe, pass, f);
    goto l25;

}



#define maxsym emax
#define maxterm 20
#define maxdegree nmax
int poly[maxdegree][maxterm],term[maxsym];
int toterms,termlist[maxterm * maxdegree][maxsym+1];
int termlistoverage;
int degterms[maxdegree];

/* code to combine like terms */

init()
{
        int i,j,k;

        for(j=0;j<maxdegree;j++)for(k=0;k<maxterm;k++)poly[j][k] = 0;

        for(i=0;i<(maxdegree * maxterm);i++)for(j=0;j<=maxsym;j++)termlist[i][j] = 0;
        for(j=0;j<maxdegree;j++)degterms[j] = 0;
        toterms = 0;
        termlistoverage = 0;

}

getexpr(sign, deg,factors,factorlist,edges)
int sign,deg,factors,edges,factorlist[];
{
        int i,j,k,l,m,n;

                for(i=0;i<maxsym;i++)term[i]=0;
                for(j = 0;j < factors;j++)
                {
                        i = getsym(factorlist[j], edges);
                       term[i] = term[i] + 1;
                };

                if(degterms[deg] == 0)
                {
                        poly[deg][0] = toterms;
                        for(i=0;i<maxsym;i++)
                               termlist[toterms][i] = term[i];
                        termlist[toterms][maxsym] = sign;
                        if (toterms >= ((maxterm * maxdegree)-1)){
                           if(termlistoverage == 0)printf("termlist is full\n\r");
                           termlistoverage++;
                        }
                        else
                           toterms++;
                        degterms[deg] = 1;

                }
                else
                {
                        for(m=0,n = 0;(m<degterms[deg]) && (n == 0);m++)
                        {
                              k = poly[deg][m];
                                        for(i=0;i<maxsym;i++)
                                                if(termlist[k][i] != term[i])break;
                                        if(i == maxsym)
                                        {
                                                n = 1;
                                                termlist[k][maxsym] += sign;
                                        /*      poly[deg][maxsym][m] += sign;*/
                                        /*        poly[deg][maxsym][m] = poly[deg][maxsym][m] + sign;*/

                                        };
                        };
                        if (n == 0)
                        {
                                k = degterms[deg];
                                poly[deg][k] = toterms;
                        for(i=0;i<maxsym;i++)
                               termlist[toterms][i] = term[i];
                        termlist[toterms][maxsym] = sign;
                        if (toterms >= ((maxterm * maxdegree)-1)){
                           if(termlistoverage == 0)printf("termlist is full\n\r");
                           termlistoverage++;
                        }
                        else
                           toterms++;
                                degterms[deg]++;


                        };
                };

}

printexp()
{
   int i,j,k,l,m,n;


  if(termlistoverage != 0)printf("termlist size exceeded by %d terms\n\r",termlistoverage);



   for(i=0,n=0;i<maxdegree;i++)
        {
                if(degterms[i] > 0)
                {
                        for(j=0,k=0;(j<degterms[i]) && (k == 0);j++)
                        {
                             l = poly[i][j];
                             if((termlist[l][maxsym] != 0))k = 1;

                         };

                     if(k == 1){
                        n++;
                        printf("\n\n + s^%-2d (\n",i);
                        for(j=0;j<degterms[i];j++)
                        {
                                l = poly[i][j];
                                if((termlist[l][maxsym] == 0))continue;
                                printf("         ");
                                {
                                        if((termlist[l][maxsym] > 1) || (termlist[l][maxsym] < 0))
                                                printf("%3d",termlist[l][maxsym]);
                                        else
                                                printf("   ");
                                };
                                for(k=0,m=0;k<maxsym;k++)
                                {
                                        if(termlist[l][k] > 0)
                                        {
                                                m = 1;
                                                if(termlist[l][k] > 1)
                                                        printf(" %s^%-2d",&branch[k][0],termlist[l][k]);
                                                else
                                                        printf(" %s   ",&branch[k][0]);
                                        };
                                };
                                if( (m == 0) && (termlist[l][maxsym] == 1)) printf(" 1");
                                printf("\n");
                        };
                        printf("        )");
                    };
                };
        };
        if(n == 0) printf("      0");
        printf("\n");
}



int getsym(i,edges)
int i,edges;
{

        int j,k,l,m;
        k = 1;
        while(k <= edges )
        {
                m = 0;
                while ((branch[k][m] == branch[i][m]) && (branch[i][m] != 0))m++;
                if (branch[k][m] == branch[i][m]) { /*printf("%s =%d\n",&branch[i][0],k);*/
                   return k;};
                k++;
        };

return i;

}


